#!/usr/bin/perl

#
# MESSAGE ENQUETE : msgenq.cgi - 2011/09/28
# Copyright (c) KentWeb
# http://www.kent-web.com/
#

# W[錾
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use Jcode;

# ݒt@CF
require "./init.cgi";
my %cf = &init;

# f[^
my %in = &parse_form;

# 
if ($in{mode} eq 'regist') { &regist; }
if ($in{mode} eq 'find') { &find_data; }
&enq_list;

#-----------------------------------------------------------
#  
#-----------------------------------------------------------
sub enq_list {
	# AP[gf[^
	my $count = 0;
	my ($op_item,@sort,@data);
	open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$item,$cnt,$hos) = split(/<>/);

		push(@sort,$cnt);
		push(@data,$_);
		$count += $cnt;

		$op_item .= qq|<option value="$no">$item\n|;
	}
	close(IN);

	# \[g
	@data = @data[sort {$sort[$b] <=> $sort[$a]} 0 .. $#sort];

	# y[W`
	my $pg = $in{pg} || 0;

	# ff[^
	my $pg = $in{pg} || 0;
	my ($i,@log);
	open(IN,"$cf{msgfile}") or &error("open err: $cf{msgfile}");
	while (<IN>) {
		my ($date,$item,$com,$name) = (split(/<>/))[0,1,2,4];
		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{pg_max});

		push(@log,$_);
	}
	close(IN);

	# Jz{^쐬
	my $page_btn = &make_pager($i, $pg);

	# NbL[擾
	my ($ck_nam) = &get_cookie;

	# ev[gǍ
	open(IN,"$cf{tmpldir}/enq.html") or &error("open err: enq.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# 摜F؍쐬
	my ($str_plain,$str_crypt);
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		($str_plain, $str_crypt) = cap::make( $cf{captcha_key}, $cf{cap_len} );
		$tmpl =~ s/!str_crypt!/$str_crypt/g;
	} else {
		$tmpl =~ s/<!-- captcha_begin -->.+<!-- captcha_end -->//s;
	}

	# u
	$tmpl =~ s/!enq_title!/$cf{enq_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/style.css|g;
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!count!/$count/g;
	$tmpl =~ s/<!-- op_item -->/$op_item/;
	$tmpl =~ s/!name!/$ck_nam/g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s/!page-btn!/<p>$page_btn<\/p>/g;
	$tmpl =~ s/!message!/$cf{message}/g;

	if ($cf{namekey} == 0) {
		$tmpl =~ s/<!-- name_begin -->.+<!-- name_end -->//s;
	}

	my ($head,$loop,$mid,$bbs,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)<!-- bbs_begin -->(.+)<!-- bbs_end -->(.+)/s) {
		($head,$loop,$mid,$bbs,$foot) = ($1,$2,$3,$4,$5);
	} else {
		&error("ev[gsł");
	}

	# ʕ\
	print "Content-type: text/html\n\n";
	print $head;

	# AP[g
	my ($i,$bf_c,$bf_r) = (0,0,1);
	foreach (@data) {
		$i++;
		my ($no,$item,$cnt) = split(/<>/);

		my ($per,$wid);
		if ($cnt == 0) {
			$per = '0.0';
			$wid = 1;
		} else {
			$per = int(($cnt*1000 / $count) + 0.5) / 10;
			$per = sprintf("%.1f", $per);
			$wid = int($per * 3) < 1 ? 1 : int($per * 3);
		}
		my $rank = $bf_c == $cnt ? $bf_r : $i;

		my $tmp = $loop;
		$tmp =~ s/!rank!/$rank/g;
		$tmp =~ s/!item!/$item/g;
		$tmp =~ s/!vote!/$cnt/g;
		$tmp =~ s/!graph!/<img src="$cf{graph}" width="$wid" height="10"> $per%/g;
		print $tmp;

		$bf_c = $cnt;
		$bf_r = $rank;
	}

	print $mid;

	# ff[^WJ
	foreach (@log) {
		my ($date,$item,$com,undef,$name) = split(/<>/);

		my $tmp = $bbs;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!item!/$item/g;
		$tmp =~ s/<!-- com_name -->/$name/g if ($cf{namekey});
		$tmp =~ s|!comment!|$com|g;
		print $tmp;
	}

	# tb^
	&footer($foot);
}

#-----------------------------------------------------------
#  [
#-----------------------------------------------------------
sub regist {
	# e`FbN
	if ($cf{postonly} && $ENV{REQUEST_METHOD} ne 'POST') {
		&error("sȃNGXgł");
	}

	# ̓`FbN
	my $err;
	if ($cf{namekey} == 1) {
	if ($in{name} eq "") { $err .= "O͂Ă܂<br>"; }
	}
	if ($in{item} eq "") { $err .= "ڂ̑I܂<br>"; }
	if ($in{comment} eq "") { $err .= "Rg͂Ă܂<br>"; }
	if (length($in{comment}) > $cf{msg_max} * 2) {
		$err .= "Rg܂BSp$cf{msg_max}ȓŋLqĉ<br>";
	}
	&error($err) if ($err);

	# 摜F؃`FbN
	if ($cf{use_captcha} > 0) {
		require $cf{captcha_pl};
		if ($in{captcha} !~ /^\d{$cf{cap_len}}$/) {
			&error("摜F؂͕słB<br>etH[ɖ߂čēǍ݌Aē͂Ă");
		}

		# eL[`FbN
		# -1 : L[sv
		#  0 : ԃI[o[
		#  1 : L[v
		my $chk = cap::check($in{captcha}, $in{str_crypt}, $cf{captcha_key}, $cf{cap_time}, $cf{cap_len});
		if ($chk == 0) {
			&error("摜F؂Ԃ𒴉߂܂B<br>etH[ɖ߂čēǍ݌Aw̐ē͂Ă");
		} elsif ($chk == -1) {
			&error("摜F؂słB<br>etH[ɖ߂čēǍ݌Aē͂Ă");
		}
	}

	# zXg擾
	my ($host,$addr) = &get_host;
	my $date = &get_time;

	my ($ans,@log);
	open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	my $top = <DAT>;
	while (<DAT>) {
		chomp;
		my ($no,$item,$count,$host) = split(/<>/);

		if ($in{item} == $no) {
			$ans = $item;
			$count++;
			$_ = "$no<>$item<>$count<>$host<>";
		}
		push(@log,"$_\n");
	}

	chomp($top);
	my $match;
	my $new_top = "$addr ";
	my $i = 0;
	foreach ( split(/\s+/, $top) ) {
		$i++;
		if ($cf{ipmax} && $addr eq $_) {
			$match = 1;
			last;
		}
		if ($i < $cf{ipmax}) { $new_top .= "$_ "; }
	}
	if ($match) {
		close(DAT);
		&error("A[͂ł܂");
	}
	$new_top =~ s/\s$//;

	# XV
	unshift(@log,"$new_top\n");
	seek(DAT, 0, 0);
	print DAT @log;
	truncate(DAT, tell(DAT));
	close(DAT);

	# RgL^
	if ($in{comment} ne "") {

		# R[hϊ
		Jcode::convert(\$in{comment}, 'sjis');

		# 
		my $date = &get_time;

		# LǍ
		open(DAT,"+< $cf{msgfile}") or &error("open err: $cf{msgfile}");
		eval "flock(DAT, 2);";
		my @data = <DAT>;

		# XV
		while ($cf{maxlog} <= @data) { pop(@data); }
		unshift(@data,"$date<>$ans<>$in{comment}<>$host<>$in{name}<>\n");
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);
	}

	# [ʒm
	&mail_to($date,$host) if ($cf{mailing} == 1);

	# NbL[i[
	&set_cookie($in{name});

	# bZ[W
	&message("񓚂肪Ƃ܂");
}

#-----------------------------------------------------------
#  [h
#-----------------------------------------------------------
sub find_data {
	# 
	$in{cond} =~ s/\D//g;

	# v_E
	my %op = (1 => 'AND', 0 => 'OR');
	my $op_cond;
	foreach (1,0) {
		if ($in{cond} eq $_) {
			$op_cond .= qq|<option value="$_" selected>$op{$_}\n|;
		} else {
			$op_cond .= qq|<option value="$_">$op{$_}\n|;
		}
	}

	# s
	my ($hit,@log) = &search($in{word},$in{cond},$cf{msgfile}) if ($in{word} ne '');

	# ev[g
	open(IN,"$cf{tmpldir}/find.html") or error("open err: find.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/style.css|g;

	# 
	my ($head,$loop,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s
			? ($1,$2,$3) : error('ev[gs');

	foreach ($head,$foot) {
		s/!enq_title!/$cf{enq_title}/g;
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/<!-- op_cond -->/$op_cond/;
		s/!word!/$in{word}/;
	}

	# wb_
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	# [v
	foreach (@log) {
		my ($date,$item,$com,undef,$name) = split(/<>/);

		my $tmp = $loop;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!item!/$item/g;
		$tmp =~ s/<!-- com_name -->/[ $name ] -/g if ($cf{namekey});
		$tmp =~ s|!comment!|$com|g;
		print $tmp;
	}

	# tb^
	footer($foot);
}

#-----------------------------------------------------------
#  s
#-----------------------------------------------------------
sub search {
	my ($word,$cond,$file,$list) = @_;

	# R[hϊ
	if ($cf{conv_code} == 1) {
		require './lib/Jcode.pm';
		$word = Jcode->new($word)->sjis;
	}

	# L[[hz
	$word =~ s/@/ /g;
	my @wd = split(/\s+/, $word);

	# L[[hiShift-JIS`j
	my $ascii = '[\x00-\x7F]';
	my $hanka = '[\xA1-\xDF]';
	my $kanji = '[\x81-\x9F\xE0-\xFC][\x40-\x7E\x80-\xFC]';

	# 
	my ($i,@log);
	open(IN,"$file") or error("open err: $file");
	while (<IN>) {
		my ($date,$item,$com,$host,$name) = split(/<>/);

		my $flg;
		foreach my $wd (@wd) {
			if ("$date,$item,$com,$host,$name" =~ /^(?:$ascii|$hanka|$kanji)*?\Q$wd\E/i) {
				$flg++;
				if ($cond == 0) { last; }
			} else {
				if ($cond == 1) { $flg = 0; last; }
			}
		}
		next if (!$flg);

		$i++;
		if ($list > 0) {
			next if ($i < $in{pg} + 1);
			next if ($i > $in{pg} + $list);
		}

		push(@log,$_);
	}
	close(IN);

	# 
	return ($i,@log);
}

#-----------------------------------------------------------
#  tb^[
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 쌠\Li폜Eϋ֎~j
	my $copy = <<EOM;
<p style="margin-top:2em;text-align:center;font-family:Verdana,Helvetica,Arial;font-size:11pt;">
- <a href="http://www.kent-web.com/" target="_top">$cf{version}</a> -<br>
++ <a href="http://www.transformsite.com/" target="_top">Edited by Hamel</a> ++
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "<body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  [M
#-----------------------------------------------------------
sub mail_to {
	my ($date,$host) = @_;

	# MIMEGR[h
	my $msub = Jcode->new("$cf{enq_title}: From $in{name}")->mime_encode;

	# Rg̉s
	my $com = &tag($in{comment});
	$com =~ s/<br>/\n/g;

	# [{`
	my $mbody = <<"EOM";
$cf{enq_title}ɓe܂B

eF$date
zXgF$host
OF$in{name}

$com
EOM

	# JISR[hϊ
	Jcode::convert(\$mbody, 'jis', 'sjis');

	# M
	my $from = $in{email} || $cf{mailto};

	# sendmailR}h
	my $scmd = "$cf{sendmail} -t -i";
	if ($cf{sendm_f}) {
		$scmd .= " -f $from";
	}

	# M
	open(MAIL,"| $scmd") or &error("Ms");
	print MAIL "To: $cf{mailto}\n";
	print MAIL "From: $cf{admin_from} <\". $cf{mailto}. \">\n";
	print MAIL "Subject: $msub\n";
	print MAIL "MIME-Version: 1.0\n";
	print MAIL "Content-type: text/plain; charset=ISO-2022-JP\n";
	print MAIL "Content-Transfer-Encoding: 7bit\n";
	print MAIL "X-Mailer: $cf{version}\n\n";
	print MAIL "$mbody\n";
	close(MAIL);
}

#-----------------------------------------------------------
#  G[
#-----------------------------------------------------------
sub error {
	my $err = shift;

	open(IN,"$cf{tmpldir}/error.html") or die;
	print "Content-type: text/html\n\n";
	while(<IN>) {

		s/!enq_title!/$cf{enq_title}/g;
		s|!bbs_css!|$cf{cmnurl}/style.css|g;
		s/!enq_cgi!/$cf{enq_cgi}/g;
		s/!error!/$err/g;

		print;
	}
	close(IN);

	exit;
}

#-----------------------------------------------------------
#  bZ[W
#-----------------------------------------------------------
sub message {
	my ($msg) = @_;

	open(IN,"$cf{tmpldir}/message.html") or &error("open err: message.html");
	print "Content-type: text/html\n\n";
	while(<IN>) {

		s/!enq_title!/$cf{enq_title}/g;
		s|!bbs_css!|$cf{cmnurl}/style.css|g;
		s/!enq_cgi!/$cf{enq_cgi}/g;
		s/!message!/$msg/g;

		print;
	}
	close(IN);

	exit;
}

#-----------------------------------------------------------
#  ؂
#-----------------------------------------------------------
sub comma {
	local($_) = @_;

	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

#-----------------------------------------------------------
#  Ԏ擾
#-----------------------------------------------------------
sub get_time {
	# 擾
	$ENV{TZ} = "JST-9";
	my ($sec,$min,$hour,$mday,$mon,$year,$wday) = (localtime(time))[0..6];

	# ̃tH[}bg
	my @week = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
	sprintf("%04d/%02d/%02d(%s) %02d:%02d:%02d",
			$year+1900,$mon+1,$mday,$week[$wday],$hour,$min,$sec);
}

#-----------------------------------------------------------
#  ANZX
#-----------------------------------------------------------
sub get_host {
	# IP&zXg擾
	my $host = $ENV{REMOTE_HOST};
	my $addr = $ENV{REMOTE_ADDR};

	if ($cf{gethostbyaddr} && ($host eq "" || $host eq $addr)) {
		$host = gethostbyaddr(pack("C4", split(/\./, $addr)), 2);
	}

	# IP`FbN
	my $flg;
	foreach ( split(/\s+/, $cf{deny_addr}) ) {
		s/\./\\\./g;
		s/\*/\.\*/g;

		if ($addr =~ /^$_/i) { $flg = 1; last; }
	}
	if ($flg) {
		&error("ANZXĂ܂");

	# zXg`FbN
	} elsif ($host) {

		foreach ( split(/\s+/, $cf{deny_host}) ) {
			s/\./\\\./g;
			s/\*/\.\*/g;

			if ($host =~ /$_$/i) { $flg = 1; last; }
		}
		if ($flg) {
			&error("ANZXĂ܂");
		}
	}
	if ($host eq "") { $host = $addr; }
	return ($host,$addr);
}

#-----------------------------------------------------------
#  y[W쐬
#-----------------------------------------------------------
sub make_pager {
	my ($i,$pg) = @_;

	# y[WJz`
	$cf{pg_max} ||= 10;
	my $next = $pg + $cf{pg_max};
	my $back = $pg - $cf{pg_max};

	# y[WJz{^쐬
	my @pg;
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$flg++;
				push(@pg,qq!<li><span>$x</span></li>!);
			} else {
				push(@pg,qq!<li><a href="$cf{bbs_cgi}?pg=$y">$x</a></li>!);
			}
			$x++;
			$y += $cf{pg_max};
			$z -= $cf{pg_max};

			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		$ret = qq!<li><a href="$cf{bbs_cgi}?pg=$back">&laquo;</a></li>\n! . $ret;
	}
	if ($next < $i) {
		$ret .= qq!<li><a href="$cf{bbs_cgi}?pg=$next">&raquo;</a></li>\n!;
	}
	
	# ʂԂ
	return $ret ? qq|<ul class="pager">$ret</ul>| : '';
}

#-----------------------------------------------------------
#  Jz{^쐬
#-----------------------------------------------------------
sub make_pgbtn {
	my ($i, $pg) = @_;

	# y[WJz`
	$cf{pg_max} ||= 10;
	my $next = $pg + $cf{pg_max};
	my $back = $pg - $cf{pg_max};

	# y[WJz{^쐬
	my $pg_btn;
	if ($back >= 0 || $next < $i) {
		$pg_btn .= "Page: ";

		my ($x, $y) = (1, 0);
		while ($i > 0) {
			if ($pg == $y) {
				$pg_btn .= qq(| <b>$x</b> );
			} else {
				$pg_btn .= qq(| <a href="$cf{enq_cgi}?pg=$y">$x</a> );
			}
			$x++;
			$y += $cf{pg_max};
			$i -= $cf{pg_max};
		}
		$pg_btn .= "|";
	}
	return $pg_btn;
}

#-----------------------------------------------------------
#  ^O
#-----------------------------------------------------------
sub tag {
	local($_) = @_;

	s/&lt;/</g;
	s/&gt;/>/g;
	s/&quot;/"/g;
	s/&amp;/&/g;
	s/&#39;/'/g;
	$_;
}

#-----------------------------------------------------------
#  NbL[擾
#-----------------------------------------------------------
sub get_cookie {
	# NbL[擾
	my $cook = $ENV{HTTP_COOKIE};

	# YIDo
	my %cook;
	foreach ( split(/;/, $cook) ) {
		my ($key,$val) = split(/=/);
		$key =~ s/\s//g;
		$cook{$key} = $val;
	}

	# URLfR[h
	my @cook;
	foreach ( split(/<>/, $cook{$cf{cookie_id}}) ) {
		s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
		s/[&"'<>]//g;

		push(@cook,$_);
	}
	return @cook;
}

#-----------------------------------------------------------
#  NbL[s
#-----------------------------------------------------------
sub set_cookie {
	my @data = @_;

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime(time + 60*24*60*60);
	my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# tH[}bg
	my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
				$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);

	# URLGR[h
	my $cook;
	foreach (@data) {
		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
		$cook .= "$_<>";
	}

	print "Set-Cookie: $cf{cookie_id}=$cook; expires=$gmt\n";
}

